//+----------------------------------------------------------------------+
//|ZigZag    Ensign    (v2)     |
//|                    |
//|      .    -  |
//|     -                                    |
//|----------------------------------------------------------------------+
//|minBars -   (  )                  |
//|minSize -     (  )  |
//|                                                                      |
//+----------------------------------------------------------------------+
#property copyright "nen"
#property link      "http://onix-trade.net/forum/index.php?s=&showtopic=118&view=findpost&p=67579"

#property indicator_separate_window
#property indicator_minimum -5
#property indicator_maximum 5
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
//---- indicator parameters
extern int minBars= 1;
extern int minSize = 15;
//-------------------------------------

//   ZigZag
double zzH[];
//   ZigZag
double zzL[];

//   ZigZag    Ensign
double si,di,lLast=0,hLast=0;
int ai,bi,ai0,bi0,fs,countBar;
datetime tai,tbi,ti;
bool fh=false,fl=false,fcount0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
// ZigZag
   SetIndexBuffer(0,zzH);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,119);
   SetIndexBuffer(1,zzL);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,119);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   if (minSize!=0) {di=minSize*Point; countBar=minBars;}

   return(0);
  }
//+------------------------------------------------------------------+
//| .
//+------------------------------------------------------------------+
int deinit() 
  {
   return(0);
  }
//********************************************************
// 
int start()
  {

   int i,n,cbi;
   
   cbi=Bars-IndicatorCounted()-1;
//---------------------------------
   for (i=cbi; i>=0; i--) 
     {
//-------------------------------------------------
      //       
      if (lLast==0) {lLast=Low[i];hLast=High[i];}

      //        .
      //         .
      if (fs==0)
        {
         if (lLast<Low[i] && hLast<High[i]) {fs=1; hLast=High[i]; si=High[i]; ai=i; tai=Time[i];}  //  
         if (lLast>Low[i] && hLast>High[i]) {fs=2; lLast=Low[i]; si=Low[i]; bi=i; tbi=Time[i];}  //  
        }

      if (ti!=Time[i])
        {
         //     fs   
         ti=Time[i];

         ai0=iBarShift(Symbol(),Period(),tai); 
         bi0=iBarShift(Symbol(),Period(),tbi);

         fcount0=false;
         if ((fh || fl) && countBar>0) {countBar--; if (i==0 && countBar==0) fcount0=true;}
         // .    .
         if (fs==1)
           {
            if (hLast>High[i] && !fh) fh=true;

            if (i==0)
              {
               if (Close[i+1]<lLast && fh) {fs=2; countBar=minBars; fh=false;}
               if (countBar==0 && si-di>Low[i+1] && High[i+1]<hLast && ai0>i+1 && fh && !fcount0) {fs=2; countBar=minBars; fh=false;}

               if (fs==2) //         
                 {
                  for (n=bi-1; n>=ai0; n--) {zzH[n]=0.001;}
                  lLast=Low[i+1];
                  si=Low[i+1];
                  bi=i+1;
                  tbi=Time[i+1];
                }
              }
            else
              {
               if (Close[i]<lLast && fh) {fs=2; countBar=minBars; fh=false;}
               if (countBar==0 && si-di>Low[i] && High[i]<hLast && fh) {fs=2; countBar=minBars; fh=false;}

               if (fs==2) //      
                 {
                  for (n=bi-1; n>=ai; n--) {zzH[n]=0.001;}
                  lLast=Low[i];
                  si=Low[i];
                  bi=i;
                  tbi=Time[i];
                 }
              }
           }
         else // fs==2
           {
            if (lLast<Low[i] && !fl) fl=true;

            if (i==0)
              {
               if (Close[i+1]>hLast && fl) {fs=1; countBar=minBars; fl=false;}
               if (countBar==0 && si+di<High[i+1] && Low[i+1]>lLast && bi0>i+1 && fl && !fcount0) {fs=1; countBar=minBars; fl=false;}

               if (fs==1) //         
                 {
                  for (n=ai-1;n>=bi0;n--) {zzL[n]=0.001;}
                  hLast=High[i+1];
                  si=High[i+1];
                  ai=i+1;
                  tai=Time[i+1];
                 }
              }
            else
              {
               if (Close[i]>hLast && fl) {fs=1; countBar=minBars; fl=false;}
               if (countBar==0 && si+di<High[i] && Low[i]>lLast && fl) {fs=1; countBar=minBars; fl=false;}

               if (fs==1) //      
                 {
                  for (n=ai-1;n>=bi;n--) {zzL[n]=0.001;}
                  hLast=High[i];
                  si=High[i];
                  ai=i;
                  tai=Time[i];
                 }
              }
           }
        } 

      //  
      if (fs==1 && High[i]>si) {ai=i; tai=Time[i]; hLast=High[i]; si=High[i]; countBar=minBars; fh=false;}
      if (fs==2 && Low[i]<si) {bi=i; tbi=Time[i]; lLast=Low[i]; si=Low[i]; countBar=minBars; fl=false;}

//===================================================================================================
      //  .    ZigZag-a

      if (i==0) 
        {
         ai0=iBarShift(Symbol(),Period(),tai); 
         bi0=iBarShift(Symbol(),Period(),tbi);

         if (fs==1) for (n=bi0-1; n>=ai0; n--) {zzH[n]=0.001;}
         if (fs==2) for (n=ai0-1; n>=bi0; n--) {zzL[n]=0.001;}
        }

//====================================================================================================
     }
//--------------------------------------------
  }